#include <iostream>
#include <vector>
#include <string>

#include "Hashtable.h"
#include "HashFunctions.h"

using namespace std;

class Recipe {
public:
  /* TODO: add */
  string name;
  int num_ingredients;
  vector<string> ingredients;

  Recipe() {}

  Recipe(string name, int num_ingredients, vector<string> ingredients) {
    /* TODO */
  }

  bool hasIngredient(string ingredient) {
    /* TODO bonus */
  }

  friend std::ostream& operator<< (std::ostream &out, const Recipe& recipe);
};

std::ostream& operator<< (std::ostream &out, const Recipe& recipe) {
  out << recipe.name << ": ";
  for (int i = 0; i < recipe.num_ingredients; ++i) {
    out << recipe.ingredients[i] << (i == (recipe.num_ingredients - 1) ? "\n" : ", ");
  }
  return out;
}

int main() {
  Hashtable<string, Recipe> recipeBook(5, &smart_hash);

  vector<string> ingredients;

  ingredients.push_back("apa");
  ingredients.push_back("sare");
  ingredients.push_back("malai");
  Recipe r1("Mamaliga", 3, ingredients);
  ingredients.clear();

  ingredients.push_back("apa");
  ingredients.push_back("zahar");
  ingredients.push_back("smantana");
  Recipe r2("Bomboane cu lapte", 3, ingredients);
  ingredients.clear();

  ingredients.push_back("apa");
  ingredients.push_back("sare");
  ingredients.push_back("malai");
  ingredients.push_back("branza");
  ingredients.push_back("smantana");
  Recipe r3("MBS", 5, ingredients);
  ingredients.clear();

  ingredients.push_back("oua");
  ingredients.push_back("faina");
  ingredients.push_back("zahar");
  ingredients.push_back("unt");
  ingredients.push_back("lapte");
  ingredients.push_back("cacao"); 
  Recipe r4("Chec", 6, ingredients);
  ingredients.clear();

  ingredients.push_back("rosii");
  ingredients.push_back("usturoi");
  ingredients.push_back("busuioc");
  ingredients.push_back("ulei de masline");
  ingredients.push_back("ceapa");
  ingredients.push_back("sare");
  ingredients.push_back("bagheta"); 
  Recipe r5("Bruschete", 7, ingredients);
  ingredients.clear();


  /* TODO: Add recipes to hashtable */
  cout << "------------------------ HASHTABLE INITIAL --------------------------\n";

  recipeBook.print_hashtable();

  cout << "\n------------------------ AFISARE RETETA -------------------------------\n";
  /* TODO: Print recipe */
  string recipeToFind = "Mamaliga";

  cout << "\n------------------------ INGREDIENT ----------------------\n";
  /* TODO: Print all recipes containing this special ingredient */
  string special_ingredient = "malai";

  cout << "\n------------------------ HASHTABLE DUPA ELIMINARI -------------------\n";
  /* TODO: Remove all recipes with more than 5 ingredients */

  recipeBook.print_hashtable();

  return 0;
}
